package HSPC::MT::Address;

use strict;

use HSPC::WebDB;
use SWsoft::protect;	# Mark this module for encryption upon build

sub get_address { 
	my $result = HSPC::WebDB::select_hash(q{select * from address where address_id=?},@_);
	return $result;
}

sub update { HSPC::WebDB::select_run(q{UPDATE address set address1=?, address2=?, city=?, state=?, state_alt=?, zip=?, country=?, phone=?, phone_src=? where address_id=?},@_); }
sub insert { HSPC::WebDB::select_run(q{INSERT INTO address (address1, address2, city, state, state_alt, zip, country, phone, phone_src) VALUES (?,?,?,?,?,?,?,?,?)},@_); }

sub get_id_from_person { 
	my $result = HSPC::WebDB::select_result(q{select address_id from person where person_id=?},@_);
	return $result; 
}

sub get_id_from_account {
	my $result = HSPC::WebDB::select_result(q{select address_id from account where account_no=?},@_);
	return $result; 
}

1;

__END__
