package HSPC::MT::Person::Role;

use strict;

use HSPC::WebDB;
use SWsoft::protect;	# Mark this module for encryption upon build

use vars qw(@ISA @EXPORT_OK);

@ISA = qw(Exporter);
@EXPORT_OK = qw(delete_person_role insert insert_person_roles get_roles_from_array get_person_name_roles get_roles has_role update);

# > account_no
# > person_id
sub delete_person_role { HSPC::WebDB::select_run(q{delete from person_account_role where account_no=? and person_id=?},@_); }

# > account_id
# > person_id
# > array person role 
sub insert { HSPC::WebDB::select_run(q{INSERT INTO person_account_role (account_no, person_id, role_id) VALUES (?,?,?)},@_); }		


# > account_id
# > person_id
# > array person role 
sub insert_person_roles {
	my $account_id = shift;
	my $person_id = shift;
	my $arr_role = shift;

	for(my $i=0; $i <= $#{$arr_role}; $i++){
		HSPC::WebDB::select_run(q{INSERT INTO person_account_role (account_no, person_id, role_id) VALUES (?,?,?)},$account_id,$person_id,${$arr_role}[$i]);
	}	
}

# > array role_id
sub get_roles_from_array { 
	my $arr_role = shift;
	
	my $where ='where';
	for(my $i=0; $i <= $#{$arr_role}; $i++){
		$where.=' or role_id='.${$arr_role}[$i];
	}
	$where =~ s/where or/where/sg;
	return HSPC::WebDB::select_rows("SELECT role_id, name from role $where");
}

sub get_person_name_roles{
	my $account_id = shift;	
	my $person_id = shift;
	my $arr_role = HSPC::WebDB::select_column(q{SELECT r.name
		from person_account_role par, role r
		where r.role_id=par.role_id and par.person_id=? and par.account_no=?},$person_id,$account_id);
	return $arr_role;	
}

sub get_roles{
	my $account_id = shift;	
	my $person_id = shift;
	return HSPC::WebDB::select_rows(q{SELECT r.role_id, r.name
		from person_account_role par, role r
		where r.role_id=par.role_id and par.person_id=? and par.account_no=?},$person_id,$account_id);
}

sub has_role {
	return HSPC::WebDB::select_result( q{
		SELECT role_id
		FROM person_account_role
		WHERE account_no = ? AND person_id = ? AND role_id = ?
	}, @_ );
}

# > account_id
# > person_id
# > array person role 
sub update {
	delete_person_role($_[0], $_[1]);
	insert_person_roles(@_);
}

1;

__END__
